/*
 * 5sec Google Authenticator
 * (c) Web factory Ltd
 */

jQuery(document).ready(function($){
  $('<option>').val('wf_ga_email_qr').text('Send emails with 5sec Authenticator QR code').appendTo("select[name='action']");

  $('#doaction').removeAttr('disabled').click(function(){
    if ($("select[name='action']").val() != 'wf_ga_email_qr') {
      return;
    }

    var num_users = $("input[name='users[]']:checked").length;
    if (!num_users) {
      alert('Please select at least one user to send an email to.');
      return false;
    }

    if (!confirm(num_users + ' selected user(s) will receive their 5sec Google Authenticator QR codes via email. Please do not close or refresh this page until the process is over. Continue?')) {
      return false;
    }

    $(this).attr('disabled', 'disabled');
    var user_ids = '';
    $("input[name='users[]']:checked").each(function(ind, el) {
      user_ids += $(el).val() + ',';
    });

    $.post(ajaxurl, {action: 'wf_ga_send_qr_emails', ajax_nonce: wf_ga.ajax_nonce, user_ids: user_ids}, function(response) {
      if (!response) {
        alert('No emails were sent. Please refresh the page and try again.');
      } else {
        alert('Email(s) were sent to ' + response + ' selected user(s).');
      }
      $('#doaction').removeAttr('disabled');
    });

    return false;
  }); // send QR emails

  $('#wf_ga_generate_secret_key').removeAttr('disabled').click(function(){
    if (!confirm('Warning! By generating a new security key you will have to add a new entry (scan the new barcode) in your mobile authenticator app. Continue?')) {
      return;
    }

    $(this).attr('disabled', 'disabled');

    $.post(ajaxurl, {action: 'wf_ga_generate_secret_key', ajax_nonce: wf_ga.ajax_nonce}, function(response) {
      if (response.length != 16) {
        alert('Bad key generated. Please reload the page and try again.');
      } else {
        $('#wf_ga_secret_key').val(response);
        $('#wf_ga_secret_key2').val(response);
        alert('New key has been generated. Please do not forget to save settings and then scan the new QR code with your mobile authenticator app.');
      }
      $('#wf_ga_generate_secret_key').removeAttr('disabled');
    }, 'json');

    return false;
  }); // generate secret key

  $('#generate_secret_url').removeAttr('disabled').click(function(){
    $(this).attr('disabled', 'disabled');

    $.post(ajaxurl, {action: 'wf_ga_generate_secret_url', ajax_nonce: wf_ga.ajax_nonce}, function(response) {
      $('#secret_login').val(response.key);
      $('#secret_login2').val(response.url);
      alert('New URL has been generated. Please don\'t forget to save settings.');
      $('#generate_secret_url').removeAttr('disabled');
    }, 'json');

    return false;
  }); // generate secret URL

  $('#add_whitelist_ip').removeAttr('disabled').click(function(){
    $(this).attr('disabled', 'disabled');

    $.post(ajaxurl, {action: 'wf_ga_my_ip', ajax_nonce: wf_ga.ajax_nonce}, function(response) {
      $('#ip_whitelist').val($.trim($('#ip_whitelist').val() + '\n' + response));
      alert('Your IP was added to the list. Please don\'t forget to save settings.');
      $('#add_whitelist_ip').removeAttr('disabled');
    }, 'json');

    return false;
  }); // add_whitelist_ip

  $('#clean_log_ban').removeAttr('disabled').click(function(){
    $(this).attr('disabled', 'disabled');

    $.post(ajaxurl, {action: 'wf_ga_clean_log_ban', ajax_nonce: wf_ga.ajax_nonce}, function(response) {
      alert('Log and ban tables have been cleaned.');
      $('#clean_log_ban').removeAttr('disabled');
    });

    return false;
  }); // clean log and ban tables

  $('#remove_bans').removeAttr('disabled').click(function(){
    $(this).attr('disabled', 'disabled');

    $.post(ajaxurl, {action: 'wf_ga_remove_bans', ajax_nonce: wf_ga.ajax_nonce}, function(response) {
      $('#ban_cnt').html('0');
      alert('All bans have been removed.');
      $('#remove_bans').removeAttr('disabled');
    });

    return false;
  }); // clean all bans

  $('#wf_ga_remove_activation_notice').click(function(){
    $('#wf_ga_activation_notice').fadeOut();

    $.post(ajaxurl, {action: 'wf_ga_remove_activation_notice'}, function(response) {
    });

    return false;
  }); // remove_activation_notice
}); // on load